#pragma once
#include "../acl_cpp_define.hpp"
#include "../stdlib/dbuf_pool.hpp"
#include "../session/session.hpp"
#include <map>

namespace acl {

class session;

/**
 *  HttpSession ࣬Ŀǰݴ洢ִֻ֧ memcached 
 */
class ACL_CPP_API HttpSession : public dbuf_obj
{
public:
	/**
	 * 캯
	 * @param session {session&} 
	 */
	HttpSession(session& session);
	virtual ~HttpSession(void);

	/**
	 * ÿͻڷ˴洢 session ֵַ
	 * @param name {const char*} session ǿ
	 * @return {const char*} session ֵصַԶǿָ룬û
	 *  ͨжϷصַǷΪմ("\0")жǷڻ
	 *  עúطǿݺûӦ̱˷ֵΪ´
	 *      ÿܻʱ
	 */
	virtual const char* getAttribute(const char* name) const;

	/**
	 * ÿͻڷ˴洢 session Ķֵ
	 * @param name {const char*} session ǿ
	 * @param size {size_t*} òǿֵǿʱַָ
	 *  洢ֵĴС
	 * @return {const void*} session ֵΪָʱ˵
	 *  ڲѯʧ
	 *  עúطǿݺûӦ̱˷ֵΪ´
	 *      ÿܻʱ
	 */
	virtual const void* getAttribute(const char* name, size_t* size) const;

	/**
	 * ӷ˻öӦͻ˵лỰԶԼ˵Ľ
	 * @param attrs {std::map<string, session_string>&}
	 * @return {bool} Ƿɹ
	 */
	virtual bool getAttributes(std::map<string, session_string>& attrs) const;

	/**
	 * ӷ˻öӦͻ˵ӦԼ
	 * @param names {const std::vector<string>&} 
	 * @param values {std::vector<session_string>&} 洢Ӧֵ
	 * @return {bool} Ƿɹ
	 */
	virtual bool getAttributes(const std::vector<string>& names,
		std::vector<session_string>& values) const;

	/**
	 * ÷ session ֵַ
	 * @param name {const char*} session ǿ
	 * @param value {const char*} session ֵǿ
	 * @return {bool}  false ˵ʧ
	 */
	virtual bool setAttribute(const char* name, const char* value);

	/**
	 * ÷ session Ķֵ
	 * @param name {const char*} session ǿ
	 * @param value {const void*} session ֵǿ
	 * @param len {size_t} value ݳ
	 * @return {bool}  false ˵ʧ
	 */
	virtual bool setAttribute(const char* name, const void* value, size_t len);

	/**
	 * ڷ session ԼϣԼ˵Ľ
	 * @param attrs {const std::map<string, session_string>&} Լ϶
	 * @return {bool} Ƿɹ
	 */
	virtual bool setAttributes(const std::map<string, session_string>& attrs);

	/**
	 * ɾͻ session еĳֵ
	 * @param name {const char*} session ǿ
	 * @return {bool} ɾǷɹ
	 */
	virtual bool removeAttribute(const char* name);

	/**
	 *  session ڻϵ
	 * @param ttl {time_t} ()
	 * @return {bool} Ƿɹ
	 */
	virtual bool setMaxAge(time_t ttl);

	/**
	 * ʹ session ӷ˵Ļɾʹ session ʧЧ
	 * @return {bool} Ƿʹ session ʧЧ
	 */
	virtual bool invalidate(void);

	/**
	 *  session ID ʶ
	 * @return {const char*} Զ '\0' βķǿָ룬ɸݷ
	 *  ֵǷΪմ("\0")ж sid Ƿ
	 */
	const char* getSid(void) const;

protected:
	session& session_;
};

} // namespace acl
