#pragma once
#include <list>

namespace acl_min
{

class connect_manager;
class connect_client;
class locker;

/**
 * ͻӳ࣬ʵֶӳصĶ̬Ϊ࣬Ҫʵ
 * 麯 create_connect ڴ˵һӣ
 * ͨ set_delay_destroy() ӳʱʵ
 * Ƕ̬
 */
class connect_pool
{
public:
	/**
	 * 캯
	 * @param addr {const char*} ַʽip:port(domain:port)
	 * @param count {int} ӳӸ
	 * @param idx {size_t} ӳضڼе±λ( 0 ʼ)
	 */
	connect_pool(const char* addr, int count, size_t idx = 0);

	/**
	 * ൱ʱʵӦΪ̬
	 */
	virtual ~connect_pool();

	/**
	 * ӳ쳣ʱ
	 * @param retry_inter {int} ӶϿٴδӵʱ()
	 *  ֵ <= 0 ʱʾӶϿ볬ʱ
	 *  ϿδñʱڲȱʡֵΪ 1 
	 * @retrun {connect_pool&}
	 */
	connect_pool& set_retry_inter(int retry_inter);

	/**
	 * ӳпӵĿ
	 * @param ttl {time_t} ӵڣֵ < 0 ʾӲڣ
	 *  == 0 ʱʾ̹ڣ> 0 ʾиʱκ󽫱ͷ
	 * @return {connect_pool&}
	 */
	connect_pool& set_idle_ttl(time_t ttl);

	/**
	 * ӳгԻȡһӣáϴη쳣ʱ
	 * δڻӳӸﵽ򽫷 NULLһµ
	 * ʱʧܣӳػᱻΪ״̬
	 * @return {connect_client*} Ϊʾ÷ӳض󲻿
	 */
	connect_client* peek();

	/**
	 * ͷһӳУӳضӦķûϣرոʱ
	 * ӽᱻֱͷ
	 * @param conn {redis_client*}
	 * @param keep {bool} ǷԸӱֳ
	 */
	void put(connect_client* conn, bool keep = true);

	/**
	 * ӳпеӣڵͷŵ
	 * @param ttl {time_t} ʱֵӽͷ
	 * @param exclusive {bool} ڲǷҪ
	 * @return {int} ͷŵĿӸ
	 */
	int check_idle(time_t ttl, bool exclusive = true);

	/**
	 * ӳصĴ״̬
	 * @param ok {bool} øǷ
	 */
	void set_alive(bool ok /* true | false */);

	/**
	 * жϱӳǷ
	 * @return {bool}
	 */
	bool aliving(void) const
	{
		return alive_;
	}

	/**
	 * ȡӳصķַ
	 * @return {const char*} طǿյַ
	 */
	const char* get_addr() const
	{
		return addr_;
	}

	/**
	 * ȡӳ
	 * @return {int}
	 */
	int get_count() const
	{
		return count_;
	}

	/**
	 * øӳضӳؼе±λ
	 * @return {size_t}
	 */
	size_t get_idx() const
	{
		return idx_;
	}

	/**
	 * ͳƼ
	 * @param inter {int} ͳƵʱ
	 */
	void reset_statistics(int inter);

	/**
	 * ȡӳܹʹõĴ
	 */
	unsigned long long get_total_used() const
	{
		return total_used_;
	}

	/**
	 * ȡӳصǰʹô
	 * @return {unsigned long long}
	 */
	unsigned long long get_current_used() const
	{
		return current_used_;
	}

protected:
	virtual connect_client* create_connect() = 0;

	friend class connect_manager;

	/**
	 * øӳضΪӳ٣ڲüΪ 0 ʱ
	 */
	void set_delay_destroy();

protected:
	bool  alive_;				// Ƿ
	bool  delay_destroy_;			// Ƿӳ
	// ķĿԵʱӳضٴαõʱ
	int   retry_inter_;
	time_t last_dead_;			// ӳضϴβʱʱ

	size_t idx_;				// ӳضڼе±λ
	char  addr_[256];			// ӳضӦķַIP:PORT
	int   max_;				// 
	int   count_;				// ǰ
	time_t idle_ttl_;			// ӵ
	time_t last_check_;			// ϴμӵʱ
	int   check_inter_;			// ӵʱ

	locker* lock_;				//  pool_ ʱĻ
	unsigned long long total_used_;		// ӳصз
	unsigned long long current_used_;	// ĳʱڵķ
	time_t last_;				// ϴμ¼ʱ
	std::list<connect_client*> pool_;	// ӳؼ
};

} // namespace acl_min
